# wownero-ng

Wownero Next Generation™℗ is a version of Wownero that:

- has modern CMake
- is easier to compile (fewer dependencies)
- installs as a library with a CMake config for easy consumption

Supported platforms:

- Linux amd64
- MacOS aarch64 (m1/m2/m3)

## Install

### Dependencies

MacOS:
```
brew install boost zeromq openssl libpgm libsodium expat libunwind-headers protobuf libgcrypt qrencode ccache cmake pkgconfig git rapidjson
```

Then install, on all platforms it is:

```bash
cmake -Bbuild .
make -Cbuild -j12
sudo make -Cbuild install 
```

wownero-ng will be installed to `/usr/local/`.

## CMake hello world

Using Wownero in your project:

```cmake
cmake_minimum_required(VERSION 3.25)
set(CMAKE_VERBOSE_MAKEFILE ON)

project(test)

set(CMAKE_CXX_STANDARD 17)

find_package(Wownero 11.1.0 REQUIRED)
add_executable(test main.cpp)

target_link_libraries(removeme PUBLIC wownero::mnemonics)
```

```cpp
#include "mnemonics/electrum-words.h"
#include "mnemonics/language_base.h"

using namespace std;
int main() {
  vector<string> language_list;
  crypto::ElectrumWords::get_language_list(language_list);

  for(const auto &lang: language_list) {
    cout << lang << "\n";
  }
}
```

## Static builds

Add `-DSTATIC=1` to the cmake command, as well as:

- `-DOPENSSL_LIBRARIES=/usr/local/openssl/lib/`
- `-DOPENSSL_ROOT_DIR=/usr/local/openssl`
- `-DBOOST_ROOT=/usr/local`

Note: you'll need these dependencies to be static too.
